	.module Wasp_TWI_Functions.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_TWI_Functions.c
	.dbfunc e Init_ADS1100_TWI _Init_ADS1100_TWI fV
;     twiaddress -> <dead>
	.even
_Init_ADS1100_TWI::
	st -y,r17
	st -y,r16
	sbiw R28,1
	.dbline -1
	.dbline 41
; /**************************************************************************
;  **************************************************************************
;  
;   Program:  Gstep_TWI_Functions		Date: Version: 0.92
;    
;    Author:  SS	  					  Date:  June 11, 2010
;    
;   Compiled with ImageCraft ICCAVR Standard V7.30.
;   
;   Copyright 2002-2009 SOC Robotics, Inc.
;  
;   TWI Functions for handling peripherals such as Motors, DRO's, joysticks
;   etc.
; 		 
;  ***************************************************************************	 
;  ***************************************************************************/
; #include <iom644v.h>
; #include <macros.h>
; #include <ctype.h>
; #include <string.h>
; #include <math.h>
; #include <stdlib.h>
; #include <eeprom.h>
; #include <stdio.h>
; 
; //#include "uart.h"
; #include "Wasp_Uart.h"
; #include "Wasp_Defines.h"
; #include "Wasp_Extern.h" 
; 
; // ***********************************************************************
; // ***********************************************************************
; //     Start of Code
; // ***********************************************************************
; // ***********************************************************************
; 
; 
; #define	   TWI_MTX_ADR_NACK  0x20
; 
; void Init_ADS1100_TWI(unsigned char twiaddress)
; {
	.dbline 44
; //unsigned char ADS1100writeAdd;
; 	//ADS1100writeAdd = (twiaddress << 1 | 0x00);
;  	 messageBuf[0] = 0x0c;
	ldi R24,12
	sts _messageBuf,R24
	.dbline 45
; 	 TWI_Start_Write(ADS1100ADDRESS,messageBuf,0);
	clr R2
	std y+0,R2
	ldi R18,<_messageBuf
	ldi R19,>_messageBuf
	ldi R16,73
	xcall _TWI_Start_Write
	.dbline -2
L1:
	.dbline 0 ; func end
	adiw R28,3
	ret
	.dbsym l twiaddress 1 c
	.dbend
	.dbfunc e Init_BMP085_TWI _Init_BMP085_TWI fV
;     twiaddress -> R10
	.even
_Init_BMP085_TWI::
	st -y,R10
	mov R10,R16
	sbiw R28,1
	.dbline -1
	.dbline 49
; }
; 
; void Init_BMP085_TWI(unsigned char twiaddress)
; {
	.dbline 50
;  	 messageBuf[0] = 0x0c;
	ldi R24,12
	sts _messageBuf,R24
	.dbline 51
; 	 TWI_Start_Write(twiaddress,messageBuf,0);
	clr R2
	std y+0,R2
	ldi R18,<_messageBuf
	ldi R19,>_messageBuf
	mov R16,R10
	xcall _TWI_Start_Write
	.dbline -2
L2:
	.dbline 0 ; func end
	adiw R28,1
	ld R10,y+
	ret
	.dbsym r twiaddress 10 c
	.dbend
	.dbfunc e Read_ADS1100_Register _Read_ADS1100_Register fc
;      iregister -> R10
;     twiaddress -> <dead>
	.even
_Read_ADS1100_Register::
	xcall push_arg4
	st -y,R10
	mov R10,R18
	.dbline -1
	.dbline 62
; }
; 
; /*
; void Write_ADS1100_Register(unsigned char twiaddress,unsigned char outbyte)
; {
;     messageBuf[0] = outbyte;
;     TWI_Start_Write(twiaddress,messageBuf,1);
; }
; */
; unsigned char Read_ADS1100_Register(unsigned char twiaddress,unsigned char iregister)
; {	//unsigned char ADS1100readAdd;
	.dbline 64
; 	//ADS1100readAdd = (twiaddress << 1 | 0x01);
; 	TWI_Start_Read(ADS1100ADDRESS,iregister);
	mov R18,R10
	ldi R16,73
	xcall _TWI_Start_Read
	.dbline 65
;     TWI_Get_Data_From_Transceiver(messageBuf,1);
	ldi R18,1
	ldi R16,<_messageBuf
	ldi R17,>_messageBuf
	xcall _TWI_Get_Data_From_Transceiver
	.dbline 66
;     return messageBuf[0];
	lds R16,_messageBuf
	.dbline -2
L3:
	.dbline 0 ; func end
	ld R10,y+
	adiw R28,4
	ret
	.dbsym r iregister 10 c
	.dbsym l twiaddress 1 c
	.dbend
	.dbfunc e Init_SmartLCD_TWI _Init_SmartLCD_TWI fV
;     twiaddress -> R10
	.even
_Init_SmartLCD_TWI::
	st -y,R10
	mov R10,R16
	sbiw R28,1
	.dbline -1
	.dbline 71
; }
; 
; // Configure SmartLCD display device via TWI to accept float
; void  Init_SmartLCD_TWI(unsigned char twiaddress)
; {
	.dbline 72
; 	 messageBuf[0] = ESC;
	ldi R24,27
	sts _messageBuf,R24
	.dbline 73
; 	 messageBuf[1] = 'c';
	ldi R24,99
	sts _messageBuf+1,R24
	.dbline 74
; 	 TWI_Start_Write(twiaddress,messageBuf,2);
	ldi R24,2
	std y+0,R24
	ldi R18,<_messageBuf
	ldi R19,>_messageBuf
	mov R16,R10
	xcall _TWI_Start_Write
	.dbline -2
L4:
	.dbline 0 ; func end
	adiw R28,1
	ld R10,y+
	ret
	.dbsym r twiaddress 10 c
	.dbend
	.dbfunc e Init_DigitalCompass_TWI _Init_DigitalCompass_TWI fV
	.even
_Init_DigitalCompass_TWI::
	sbiw R28,1
	.dbline -1
	.dbline 79
; }
; 
; // Start a measurement event in the Digital Compass
; void  Init_DigitalCompass_TWI()
; {
	.dbline 80
; 	 messageBuf[0] = 'W';  // Exit sleep state
	ldi R24,87
	sts _messageBuf,R24
	.dbline 81
; 	 TWI_Start_Write(DIGITALCOMPASSTWIADDRESS,messageBuf,1);
	ldi R24,1
	std y+0,R24
	ldi R18,<_messageBuf
	ldi R19,>_messageBuf
	ldi R16,33
	xcall _TWI_Start_Write
	.dbline -2
L6:
	.dbline 0 ; func end
	adiw R28,1
	ret
	.dbend
	.dbfunc e Write_DigitalCompass_Register _Write_DigitalCompass_Register fV
;        outbyte -> R12
;     twiaddress -> R10
	.even
_Write_DigitalCompass_Register::
	st -y,R10
	st -y,R12
	mov R12,R18
	mov R10,R16
	sbiw R28,1
	.dbline -1
	.dbline 85
; }
; 
; void Write_DigitalCompass_Register(unsigned char twiaddress,unsigned char outbyte)
; {
	.dbline 86
;     messageBuf[0] = outbyte;
	sts _messageBuf,R12
	.dbline 87
;     TWI_Start_Write(twiaddress,messageBuf,1);
	ldi R24,1
	std y+0,R24
	ldi R18,<_messageBuf
	ldi R19,>_messageBuf
	mov R16,R10
	xcall _TWI_Start_Write
	.dbline -2
L7:
	.dbline 0 ; func end
	adiw R28,1
	ld R12,y+
	ld R10,y+
	ret
	.dbsym r outbyte 12 c
	.dbsym r twiaddress 10 c
	.dbend
	.dbfunc e Read_DigitalCompass_Register _Read_DigitalCompass_Register fc
;      iregister -> R12
;     twiaddress -> R10
	.even
_Read_DigitalCompass_Register::
	st -y,R10
	st -y,R12
	mov R12,R18
	mov R10,R16
	.dbline -1
	.dbline 91
; }
; 
; unsigned char Read_DigitalCompass_Register(unsigned char twiaddress,unsigned char iregister)
; {
	.dbline 92
; 	TWI_Start_Read(twiaddress,iregister);
	mov R18,R12
	mov R16,R10
	xcall _TWI_Start_Read
	.dbline 93
;     TWI_Get_Data_From_Transceiver(messageBuf,1);
	ldi R18,1
	ldi R16,<_messageBuf
	ldi R17,>_messageBuf
	xcall _TWI_Get_Data_From_Transceiver
	.dbline 94
;     return messageBuf[0];
	lds R16,_messageBuf
	.dbline -2
L8:
	.dbline 0 ; func end
	ld R12,y+
	ld R10,y+
	ret
	.dbsym r iregister 12 c
	.dbsym r twiaddress 10 c
	.dbend
	.dbfunc e Read_HMC5883_Register _Read_HMC5883_Register fc
;      iregister -> R10
	.even
_Read_HMC5883_Register::
	st -y,R10
	mov R10,R16
	sbiw R28,1
	.dbline -1
	.dbline 98
; }
; 
; unsigned char Read_HMC5883_Register(unsigned char iregister)
; {
	.dbline 99
; 	messageBuf[0] = iregister;
	sts _messageBuf,R10
	.dbline 100
; 	TWI_Start_Write(HMC5883TWIADDRESS,messageBuf,1);
	ldi R24,1
	std y+0,R24
	ldi R18,<_messageBuf
	ldi R19,>_messageBuf
	ldi R16,30
	xcall _TWI_Start_Write
	.dbline 101
; 	TWI_Start_Read(HMC5883TWIADDRESS,1);
	ldi R18,1
	ldi R16,30
	xcall _TWI_Start_Read
	.dbline 102
;     TWI_Get_Data_From_Transceiver(messageBuf,1);
	ldi R18,1
	ldi R16,<_messageBuf
	ldi R17,>_messageBuf
	xcall _TWI_Get_Data_From_Transceiver
	.dbline 103
;     return messageBuf[0];
	lds R16,_messageBuf
	.dbline -2
L9:
	.dbline 0 ; func end
	adiw R28,1
	ld R10,y+
	ret
	.dbsym r iregister 10 c
	.dbend
	.dbfunc e Write_HMC5883_Register _Write_HMC5883_Register fV
;           data -> R10
;      iregister -> R12
	.even
_Write_HMC5883_Register::
	st -y,R10
	st -y,R12
	mov R10,R18
	mov R12,R16
	sbiw R28,1
	.dbline -1
	.dbline 107
; }
; 
; void Write_HMC5883_Register(unsigned char iregister,unsigned char data)
; {
	.dbline 108
; 	messageBuf[0] = iregister;
	sts _messageBuf,R12
	.dbline 109
; 	messageBuf[1] = data;
	sts _messageBuf+1,R10
	.dbline 110
; 	TWI_Start_Write(HMC5883TWIADDRESS,messageBuf,2);
	ldi R24,2
	std y+0,R24
	ldi R18,<_messageBuf
	ldi R19,>_messageBuf
	ldi R16,30
	xcall _TWI_Start_Write
	.dbline -2
L10:
	.dbline 0 ; func end
	adiw R28,1
	ld R12,y+
	ld R10,y+
	ret
	.dbsym r data 10 c
	.dbsym r iregister 12 c
	.dbend
	.dbfunc e Init_HMC5883_TWI _Init_HMC5883_TWI fV
	.even
_Init_HMC5883_TWI::
	sbiw R28,1
	.dbline -1
	.dbline 114
; }
; 
; void Init_HMC5883_TWI()
; {
	.dbline 115
; 	messageBuf[0] = HMC5883_MODE_REG;
	ldi R24,2
	sts _messageBuf,R24
	.dbline 116
; 	messageBuf[1] = HMC5883_CONTINUOUS_M;  // Set continuous measurement mode
	clr R2
	sts _messageBuf+1,R2
	.dbline 117
; 	TWI_Start_Write(HMC5883TWIADDRESS,messageBuf,2);
	std y+0,R24
	ldi R18,<_messageBuf
	ldi R19,>_messageBuf
	ldi R16,30
	xcall _TWI_Start_Write
	.dbline -2
L12:
	.dbline 0 ; func end
	adiw R28,1
	ret
	.dbend
	.dbfunc e flipByte _flipByte fc
; flippedByteCopy -> R12
;    flippedByte -> R10
;     byteToFlip -> R16
	.even
_flipByte::
	st -y,R10
	st -y,R12
	.dbline -1
	.dbline 121
; }
; 
; unsigned char flipByte(unsigned char byteToFlip)
; {		unsigned char flippedByte; 
	.dbline 124
; 
; 		unsigned char flippedByteCopy; 
; 		flippedByte = 0x00;
	clr R10
	.dbline 126
; 		
; 		flippedByteCopy = byteToFlip;
	mov R12,R16
	.dbline 127
; 		flippedByte |= (0b00001000 & (flippedByteCopy >> 1 ));
	mov R24,R12
	lsr R24
	andi R24,8
	or R10,R24
	.dbline 128
; 		flippedByte |= (0b00000100 & (flippedByteCopy >> 2 ));
	mov R24,R12
	lsr R24
	lsr R24
	andi R24,4
	or R10,R24
	.dbline 129
; 		flippedByte |= (0b00000010 & (flippedByteCopy >> 2 ));
	mov R24,R12
	lsr R24
	lsr R24
	andi R24,2
	or R10,R24
	.dbline 130
; 		flippedByte |= (0b00000001 & (flippedByteCopy >> 2 ));
	mov R24,R12
	lsr R24
	lsr R24
	andi R24,1
	or R10,R24
	.dbline 133
; 		
; 		 
; 		flippedByteCopy = byteToFlip;
	.dbline 134
; 		flippedByte |= (0b00010000 & (flippedByteCopy << 1 ));
	mov R24,R12
	lsl R24
	andi R24,16
	or R10,R24
	.dbline 135
; 		flippedByte |= (0b00100000 & (flippedByteCopy << 2 ));
	mov R24,R12
	lsl R24
	lsl R24
	andi R24,32
	or R10,R24
	.dbline 136
; 		flippedByte |= (0b01000000 & (flippedByteCopy << 2 ));
	mov R24,R12
	lsl R24
	lsl R24
	andi R24,64
	or R10,R24
	.dbline 137
; 		flippedByte |= (0b10000000 & (flippedByteCopy << 2 ));
	mov R24,R12
	lsl R24
	lsl R24
	andi R24,128
	or R10,R24
	.dbline 139
; 		 
; 		return flippedByte; 
	mov R16,R10
	.dbline -2
L14:
	.dbline 0 ; func end
	ld R12,y+
	ld R10,y+
	ret
	.dbsym r flippedByteCopy 12 c
	.dbsym r flippedByte 10 c
	.dbsym r byteToFlip 16 c
	.dbend
	.dbfunc e Read_ADS1100 _Read_ADS1100 fi
	.dbunion 1 2 .16
	.dbfield 0 tempbuf A[2:2]c
	.dbfield 0 outint I
	.dbend
;     ADSreading -> <dead>
;    returnValue -> R10,R11
;              u -> y+0
	.even
_Read_ADS1100::
	st -y,R10
	st -y,R11
	sbiw R28,2
	.dbline -1
	.dbline 143
; }
; 
; unsigned int Read_ADS1100()
; {		
	.dbline 151
;  	unsigned char ADSreading;
; 	unsigned int returnValue;
; 	union {
; 	    unsigned char tempbuf[2];
; 		int outint;
; 		} u;
; 	
; 	u.outint = 0;
	clr R2
	clr R3
	std y+1,R3
	std y+0,R2
	.dbline 152
; 	TWI_Start_Read(ADS1100ADDRESS,3);
	ldi R18,3
	ldi R16,73
	xcall _TWI_Start_Read
	.dbline 153
;     TWI_Get_Data_From_Transceiver(messageBuf,3);
	ldi R18,3
	ldi R16,<_messageBuf
	ldi R17,>_messageBuf
	xcall _TWI_Get_Data_From_Transceiver
	.dbline 154
; 	u.tempbuf[1] = messageBuf[0];
	lds R2,_messageBuf
	std y+1,R2
	.dbline 155
; 	u.tempbuf[0] = messageBuf[1];
	lds R2,_messageBuf+1
	std y+0,R2
	.dbline 156
; 	returnValue = u.outint ;//+ 32768;
	ldd R10,y+0
	ldd R11,y+1
	.dbline 160
; //	printf("\nmessageBuff0: %x\n\r", messageBuf[0]);
; //	printf(" messageBuff1: %x\n\r", messageBuf[1]);
; //	printf("messageBuff2: %x\n\r", messageBuf[2]);
;     return returnValue;
	movw R16,R10
	.dbline -2
L15:
	.dbline 0 ; func end
	adiw R28,2
	ld R11,y+
	ld R10,y+
	ret
	.dbsym l ADSreading 1 c
	.dbsym r returnValue 10 i
	.dbsym l u 0 S[.16]
	.dbend
	.dbfunc e Read_BMP085_EEPROM _Read_BMP085_EEPROM fc
;  eepromaddress -> R10
	.even
_Read_BMP085_EEPROM::
	st -y,R10
	mov R10,R16
	sbiw R28,1
	.dbline -1
	.dbline 164
; }
; 
; unsigned char Read_BMP085_EEPROM(unsigned char eepromaddress)
; {
	.dbline 165
; 	messageBuf[0] = eepromaddress;
	sts _messageBuf,R10
	.dbline 166
;     TWI_Start_Write(BMP085TWIADDRESS,messageBuf,1);
	ldi R24,1
	std y+0,R24
	ldi R18,<_messageBuf
	ldi R19,>_messageBuf
	ldi R16,119
	xcall _TWI_Start_Write
	.dbline 167
; 	messageBuf[0] = 0;
	clr R2
	sts _messageBuf,R2
	.dbline 168
; 	TWI_Start_Read(BMP085TWIADDRESS,1);
	ldi R18,1
	ldi R16,119
	xcall _TWI_Start_Read
	.dbline 169
;     TWI_Get_Data_From_Transceiver(messageBuf,1);
	ldi R18,1
	ldi R16,<_messageBuf
	ldi R17,>_messageBuf
	xcall _TWI_Get_Data_From_Transceiver
	.dbline 170
; 	return messageBuf[0];
	lds R16,_messageBuf
	.dbline -2
L19:
	.dbline 0 ; func end
	adiw R28,1
	ld R10,y+
	ret
	.dbsym r eepromaddress 10 c
	.dbend
	.dbfunc e Read_BMP085_EEPROM_Signed _Read_BMP085_EEPROM_Signed fI
	.dbunion 1 2 .21
	.dbfield 0 tempbuf A[2:2]c
	.dbfield 0 outint I
	.dbend
;              u -> y+0
;  eepromaddress -> R20
	.even
_Read_BMP085_EEPROM_Signed::
	xcall push_xgset300C
	mov R20,R16
	sbiw R28,2
	.dbline -1
	.dbline 174
; }
; 
; int Read_BMP085_EEPROM_Signed(unsigned char eepromaddress)
; {
	.dbline 180
; 	union {
; 	    unsigned char tempbuf[2];
; 		int outint;
; 		} u;
; 	
; 	u.outint = 0;
	clr R2
	clr R3
	std y+1,R3
	std y+0,R2
	.dbline 181
; 	u.tempbuf[1] = Read_BMP085_EEPROM(eepromaddress++);
	mov R2,R20
	subi R20,255    ; addi 1
	mov R16,R2
	xcall _Read_BMP085_EEPROM
	std y+1,R16
	.dbline 182
; 	u.tempbuf[0] = Read_BMP085_EEPROM(eepromaddress);
	mov R16,R20
	xcall _Read_BMP085_EEPROM
	mov R10,R16
	std y+0,R10
	.dbline 183
;     return u.outint;  
	ldd R16,y+0
	ldd R17,y+1
	.dbline -2
L20:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgset300C
	.dbsym l u 0 S[.21]
	.dbsym r eepromaddress 20 c
	.dbend
	.dbfunc e Read_BMP085_EEPROM_UnSigned _Read_BMP085_EEPROM_UnSigned fi
	.dbunion 1 2 .24
	.dbfield 0 tempbuf A[2:2]c
	.dbfield 0 outint i
	.dbend
;              u -> y+0
;  eepromaddress -> R20
	.even
_Read_BMP085_EEPROM_UnSigned::
	xcall push_xgset300C
	mov R20,R16
	sbiw R28,2
	.dbline -1
	.dbline 187
; }
; 
; unsigned int Read_BMP085_EEPROM_UnSigned(unsigned char eepromaddress)
; {
	.dbline 193
; 	union {
; 	    unsigned char tempbuf[2];
; 		unsigned int outint;
; 		} u;
; 	
; 	u.outint = 0;
	clr R2
	clr R3
	std y+1,R3
	std y+0,R2
	.dbline 194
; 	u.tempbuf[1] = Read_BMP085_EEPROM(eepromaddress++);
	mov R2,R20
	subi R20,255    ; addi 1
	mov R16,R2
	xcall _Read_BMP085_EEPROM
	std y+1,R16
	.dbline 195
; 	u.tempbuf[0] = Read_BMP085_EEPROM(eepromaddress);
	mov R16,R20
	xcall _Read_BMP085_EEPROM
	mov R10,R16
	std y+0,R10
	.dbline 196
;     return u.outint;  
	ldd R16,y+0
	ldd R17,y+1
	.dbline -2
L23:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgset300C
	.dbsym l u 0 S[.24]
	.dbsym r eepromaddress 20 c
	.dbend
	.dbfunc e Load_BMP085_Parameters _Load_BMP085_Parameters fV
	.even
_Load_BMP085_Parameters::
	st -y,R10
	st -y,R11
	.dbline -1
	.dbline 200
; }
; 
; void Load_BMP085_Parameters()
; {
	.dbline 201
;  	 bmpac1=bmpac2=bmpac3=bmpb1=bmpb2=bmpmb=bmpmc=bmpmd=0;
	clr R2
	clr R3
	sts _bmpmd+1,R3
	sts _bmpmd,R2
	sts _bmpmc+1,R3
	sts _bmpmc,R2
	sts _bmpmb+1,R3
	sts _bmpmb,R2
	sts _bmpb2+1,R3
	sts _bmpb2,R2
	sts _bmpb1+1,R3
	sts _bmpb1,R2
	sts _bmpac3+1,R3
	sts _bmpac3,R2
	sts _bmpac2+1,R3
	sts _bmpac2,R2
	sts _bmpac1+1,R3
	sts _bmpac1,R2
	.dbline 202
; 	 bmpac4=bmpac5=bmpac6=0;
	sts _bmpac6+1,R3
	sts _bmpac6,R2
	sts _bmpac5+1,R3
	sts _bmpac5,R2
	sts _bmpac4+1,R3
	sts _bmpac4,R2
	.dbline 205
; 
;  	 // Read signed BMP085 Parameters
; 	 bmpac1 = Read_BMP085_EEPROM_Signed(0xaa);
	ldi R16,170
	xcall _Read_BMP085_EEPROM_Signed
	sts _bmpac1+1,R17
	sts _bmpac1,R16
	.dbline 206
; 	 bmpac2 = Read_BMP085_EEPROM_Signed(0xac);
	ldi R16,172
	xcall _Read_BMP085_EEPROM_Signed
	sts _bmpac2+1,R17
	sts _bmpac2,R16
	.dbline 207
; 	 bmpac3 = Read_BMP085_EEPROM_Signed(0xae);
	ldi R16,174
	xcall _Read_BMP085_EEPROM_Signed
	movw R10,R16
	sts _bmpac3+1,R11
	sts _bmpac3,R10
	.dbline 208
; 	 bmpb1 = Read_BMP085_EEPROM_Signed(0xb6);
	ldi R16,182
	xcall _Read_BMP085_EEPROM_Signed
	movw R10,R16
	sts _bmpb1+1,R11
	sts _bmpb1,R10
	.dbline 209
; 	 bmpb2 = Read_BMP085_EEPROM_Signed(0xb8);
	ldi R16,184
	xcall _Read_BMP085_EEPROM_Signed
	movw R10,R16
	sts _bmpb2+1,R11
	sts _bmpb2,R10
	.dbline 210
; 	 bmpmb = Read_BMP085_EEPROM_Signed(0xba);
	ldi R16,186
	xcall _Read_BMP085_EEPROM_Signed
	movw R10,R16
	sts _bmpmb+1,R11
	sts _bmpmb,R10
	.dbline 211
; 	 bmpmc = Read_BMP085_EEPROM_Signed(0xbc);
	ldi R16,188
	xcall _Read_BMP085_EEPROM_Signed
	movw R10,R16
	sts _bmpmc+1,R11
	sts _bmpmc,R10
	.dbline 212
; 	 bmpmd = Read_BMP085_EEPROM_Signed(0xbe);
	ldi R16,190
	xcall _Read_BMP085_EEPROM_Signed
	movw R10,R16
	sts _bmpmd+1,R11
	sts _bmpmd,R10
	.dbline 213
; 	 if(0) {
	xjmp L27
L27:
	.dbline 226
; 	     printf("\n\rBMP085 Calibration Parameters\n\r");
; 	     printf("ac1=%d\n\r",bmpac1);
; 	     printf("ac2=%d\n\r",bmpac2);
; 	     printf("ac3=%d\n\r",bmpac3);
; 	     printf("bp1=%d\n\r",bmpb1);
; 	     printf("bp2=%d\n\r",bmpb2);
; 	     printf("mb=%d\n\r",bmpmb);
; 	     printf("mc=%d\n\r",bmpmc);
; 	     printf("md=%d\n\r",bmpmd);
; 		 }
; 	 
; 	 // Read unsigned BMP085 parameters
; 	 bmpac4 = Read_BMP085_EEPROM_UnSigned(0xb0);
	ldi R16,176
	xcall _Read_BMP085_EEPROM_UnSigned
	movw R10,R16
	sts _bmpac4+1,R11
	sts _bmpac4,R10
	.dbline 227
; 	 bmpac5 = Read_BMP085_EEPROM_UnSigned(0xb2);
	ldi R16,178
	xcall _Read_BMP085_EEPROM_UnSigned
	movw R10,R16
	sts _bmpac5+1,R11
	sts _bmpac5,R10
	.dbline 228
; 	 bmpac6 = Read_BMP085_EEPROM_UnSigned(0xb4);
	ldi R16,180
	xcall _Read_BMP085_EEPROM_UnSigned
	movw R10,R16
	sts _bmpac6+1,R11
	sts _bmpac6,R10
	.dbline 229
; 	 if(0) {
	xjmp L38
L38:
	.dbline -2
L26:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	ret
	.dbend
	.dbfunc e Read_BMP085_Pressure _Read_BMP085_Pressure fi
	.dbunion 1 2 .44
	.dbfield 0 tempbuf A[2:2]c
	.dbfield 0 outint i
	.dbend
;              u -> y+1
	.even
_Read_BMP085_Pressure::
	sbiw R28,3
	.dbline -1
	.dbline 237
; 	     printf("ac4=%u\n\r",bmpac4);
; 	     printf("ac5=%u\n\r",bmpac5);
; 	     printf("ac6=%u\n\r",bmpac6);
; 		 }
; }
; 
; unsigned int Read_BMP085_Pressure()
; {
	.dbline 243
; 	union {
; 	    unsigned char tempbuf[2];
; 		unsigned int outint;
; 		} u;
; 	
; 	u.outint = 0;
	clr R2
	clr R3
	std y+2,R3
	std y+1,R2
	.dbline 245
;     //printf("\n\rRead barometric pressure\n\r");
; 	messageBuf[0] = 0xf4;
	ldi R24,244
	sts _messageBuf,R24
	.dbline 246
; 	messageBuf[1] = 0xb4;
	ldi R24,180
	sts _messageBuf+1,R24
	.dbline 247
;     TWI_Start_Write(BMP085TWIADDRESS,messageBuf,2);
	ldi R24,2
	std y+0,R24
	ldi R18,<_messageBuf
	ldi R19,>_messageBuf
	ldi R16,119
	xcall _TWI_Start_Write
	.dbline 248
; 	Delaymsec(28);
	ldi R16,28
	ldi R17,0
	xcall _Delaymsec
	.dbline 249
; 	messageBuf[0] = 0xf6;
	ldi R24,246
	sts _messageBuf,R24
	.dbline 250
;     TWI_Start_Write(BMP085TWIADDRESS,messageBuf,1);
	ldi R24,1
	std y+0,R24
	ldi R18,<_messageBuf
	ldi R19,>_messageBuf
	ldi R16,119
	xcall _TWI_Start_Write
	.dbline 251
; 	messageBuf[0] = 0;
	clr R2
	sts _messageBuf,R2
	.dbline 252
; 	messageBuf[1] = 0;
	sts _messageBuf+1,R2
	.dbline 253
; 	TWI_Start_Read(BMP085TWIADDRESS,2);
	ldi R18,2
	ldi R16,119
	xcall _TWI_Start_Read
	.dbline 254
;     TWI_Get_Data_From_Transceiver(messageBuf,2);
	ldi R18,2
	ldi R16,<_messageBuf
	ldi R17,>_messageBuf
	xcall _TWI_Get_Data_From_Transceiver
	.dbline 255
; 	u.tempbuf[1] = messageBuf[0];
	lds R2,_messageBuf
	std y+2,R2
	.dbline 256
; 	u.tempbuf[0] = messageBuf[1];
	lds R2,_messageBuf+1
	std y+1,R2
	.dbline 260
; 	//printf("mb[0]= %x\n\r",messageBuf[0]);
; 	//printf("mb[1]= %x\n\r",messageBuf[1]);
; 	
;     return u.outint;
	ldd R16,y+1
	ldd R17,y+2
	.dbline -2
L43:
	.dbline 0 ; func end
	adiw R28,3
	ret
	.dbsym l u 1 S[.44]
	.dbend
	.dbfunc e Read_BMP085_Temperature _Read_BMP085_Temperature fi
	.dbunion 1 2 .50
	.dbfield 0 tempbuf A[2:2]c
	.dbfield 0 outint i
	.dbend
;              u -> y+1
	.even
_Read_BMP085_Temperature::
	sbiw R28,3
	.dbline -1
	.dbline 264
; }
; 
; unsigned int Read_BMP085_Temperature()
; {
	.dbline 270
; 	union {
; 	    unsigned char tempbuf[2];
; 		unsigned int outint;
; 		} u;
; 	
; 	u.outint = 0;
	clr R2
	clr R3
	std y+2,R3
	std y+1,R2
	.dbline 272
;     //printf("\n\rRead temperature\n\r");
; 	messageBuf[0] = 0xf4;
	ldi R24,244
	sts _messageBuf,R24
	.dbline 273
; 	messageBuf[1] = 0x2e;
	ldi R24,46
	sts _messageBuf+1,R24
	.dbline 274
;     TWI_Start_Write(BMP085TWIADDRESS,messageBuf,2);
	ldi R24,2
	std y+0,R24
	ldi R18,<_messageBuf
	ldi R19,>_messageBuf
	ldi R16,119
	xcall _TWI_Start_Write
	.dbline 275
; 	Delaymsec(6);
	ldi R16,6
	ldi R17,0
	xcall _Delaymsec
	.dbline 276
; 	messageBuf[0] = 0xf6;
	ldi R24,246
	sts _messageBuf,R24
	.dbline 277
;     TWI_Start_Write(BMP085TWIADDRESS,messageBuf,1);
	ldi R24,1
	std y+0,R24
	ldi R18,<_messageBuf
	ldi R19,>_messageBuf
	ldi R16,119
	xcall _TWI_Start_Write
	.dbline 278
; 	messageBuf[0] = 0;
	clr R2
	sts _messageBuf,R2
	.dbline 279
; 	messageBuf[1] = 0;
	sts _messageBuf+1,R2
	.dbline 280
; 	TWI_Start_Read(BMP085TWIADDRESS,2);
	ldi R18,2
	ldi R16,119
	xcall _TWI_Start_Read
	.dbline 281
;     TWI_Get_Data_From_Transceiver(messageBuf,2);
	ldi R18,2
	ldi R16,<_messageBuf
	ldi R17,>_messageBuf
	xcall _TWI_Get_Data_From_Transceiver
	.dbline 282
; 	u.tempbuf[1] = messageBuf[0];
	lds R2,_messageBuf
	std y+2,R2
	.dbline 283
; 	u.tempbuf[0] = messageBuf[1];
	lds R2,_messageBuf+1
	std y+1,R2
	.dbline 287
; 	//printf("mb[0]= %x\n\r",messageBuf[0]);
; 	//printf("mb[1]= %x\n\r",messageBuf[1]);
; 	
;     return u.outint;
	ldd R16,y+1
	ldd R17,y+2
	.dbline -2
L49:
	.dbline 0 ; func end
	adiw R28,3
	ret
	.dbsym l u 1 S[.50]
	.dbend
	.dbfunc e Read_DigitalCompass_Heading _Read_DigitalCompass_Heading fi
	.dbunion 1 2 .56
	.dbfield 0 tempbuf A[2:2]c
	.dbfield 0 outint i
	.dbend
;              u -> y+0
	.even
_Read_DigitalCompass_Heading::
	sbiw R28,2
	.dbline -1
	.dbline 290
; }
; unsigned int Read_DigitalCompass_Heading()
; {
	.dbline 296
; 	union {
; 	    unsigned char tempbuf[2];
; 		unsigned int outint;
; 		} u;
; 	
; 	u.outint = 0;
	clr R2
	clr R3
	std y+1,R3
	std y+0,R2
	.dbline 297
; 	Write_DigitalCompass_Register(DIGITALCOMPASSTWIADDRESS,'A');
	ldi R18,65
	ldi R16,33
	xcall _Write_DigitalCompass_Register
	.dbline 299
;     //printf("\n\rRead digital compass\n\r");
; 	TWI_Start_Read(DIGITALCOMPASSTWIADDRESS,3);
	ldi R18,3
	ldi R16,33
	xcall _TWI_Start_Read
	.dbline 300
;     TWI_Get_Data_From_Transceiver(messageBuf,2);
	ldi R18,2
	ldi R16,<_messageBuf
	ldi R17,>_messageBuf
	xcall _TWI_Get_Data_From_Transceiver
	.dbline 301
; 	u.tempbuf[1] = messageBuf[0];
	lds R2,_messageBuf
	std y+1,R2
	.dbline 302
; 	u.tempbuf[0] = messageBuf[1];
	lds R2,_messageBuf+1
	std y+0,R2
	.dbline 306
; 	//printf("messagebug[0]=%x\n\r",messageBuf[0]);
; 	//printf("messagebug[1]=%x\n\r",messageBuf[1]);
; 	
;     return u.outint;
	ldd R16,y+0
	ldd R17,y+1
	.dbline -2
L55:
	.dbline 0 ; func end
	adiw R28,2
	ret
	.dbsym l u 0 S[.56]
	.dbend
	.dbfunc e Write_Float_SmartLCD _Write_Float_SmartLCD fV
;          value -> R20,R21
;         fvalue -> y+7
;         axisid -> R12
;     twiaddress -> R10
	.even
_Write_Float_SmartLCD::
	xcall push_xgset303C
	mov R12,R18
	mov R10,R16
	sbiw R28,1
	.dbline -1
	.dbline 311
; }
; 
; // Write float value to LED8 via TWI
; void Write_Float_SmartLCD(unsigned char twiaddress,unsigned char axisid,float fvalue)
; {
	.dbline 314
;  	 void *value;
; 	 
; 	 messageBuf[0] = 'm';
	ldi R24,109
	sts _messageBuf,R24
	.dbline 315
; 	 messageBuf[1] = axisid;
	sts _messageBuf+1,R12
	.dbline 316
; 	 value = &messageBuf[2];
	ldi R20,<_messageBuf+2
	ldi R21,>_messageBuf+2
	.dbline 317
; 	 *(float *)value = fvalue;
	ldd R2,y+7
	ldd R3,y+8
	ldd R4,y+9
	ldd R5,y+10
	movw R30,R20
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
	.dbline 318
; 	 TWI_Start_Write(twiaddress,messageBuf,6);
	ldi R24,6
	std y+0,R24
	ldi R18,<_messageBuf
	ldi R19,>_messageBuf
	mov R16,R10
	xcall _TWI_Start_Write
	.dbline -2
L59:
	.dbline 0 ; func end
	adiw R28,1
	xjmp pop_xgset303C
	.dbsym r value 20 pV
	.dbsym l fvalue 7 D
	.dbsym r axisid 12 c
	.dbsym r twiaddress 10 c
	.dbend
	.dbfunc e Read_SmartLCD_Switches _Read_SmartLCD_Switches fc
;     twiaddress -> R10
	.even
_Read_SmartLCD_Switches::
	st -y,R10
	mov R10,R16
	.dbline -1
	.dbline 322
; }
; 
; unsigned char Read_SmartLCD_Switches(char twiaddress)
; {
	.dbline 323
; 	TWI_Start_Read(twiaddress,3);
	ldi R18,3
	mov R16,R10
	xcall _TWI_Start_Read
	.dbline 324
;     TWI_Get_Data_From_Transceiver(messageBuf,1);
	ldi R18,1
	ldi R16,<_messageBuf
	ldi R17,>_messageBuf
	xcall _TWI_Get_Data_From_Transceiver
	.dbline 325
;     return messageBuf[0];
	lds R16,_messageBuf
	.dbline -2
L62:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r twiaddress 10 c
	.dbend
	.dbfunc e putcharSmartLCD _putcharSmartLCD fV
;         inchar -> R10
	.even
_putcharSmartLCD::
	st -y,R10
	mov R10,R16
	sbiw R28,1
	.dbline -1
	.dbline 329
; }
; 
; void putcharSmartLCD(char inchar)
; {	 
	.dbline 330
; 	 messageBuf[0] = inchar;
	sts _messageBuf,R10
	.dbline 331
; 	 TWI_Start_Write(SMARTLCDTWIADDRESS,messageBuf,1);
	ldi R24,1
	std y+0,R24
	ldi R18,<_messageBuf
	ldi R19,>_messageBuf
	ldi R16,38
	xcall _TWI_Start_Write
	.dbline -2
L63:
	.dbline 0 ; func end
	adiw R28,1
	ld R10,y+
	ret
	.dbsym r inchar 10 c
	.dbend
	.dbfunc e putsSmartLCD _putsSmartLCD fV
;              i -> R10
;           strg -> R12,R13
	.even
_putsSmartLCD::
	xcall push_xgset003C
	movw R12,R16
	.dbline -1
	.dbline 335
; }
; 
; void putsSmartLCD(char *strg)
; {
	.dbline 338
;  	unsigned char i;
; 	
;  	for(i=0; i<strlen(strg); i++) {
	clr R10
	xjmp L68
L65:
	.dbline 338
	.dbline 339
; 	    putcharSmartLCD(strg[i]);
	mov R30,R10
	clr R31
	add R30,R12
	adc R31,R13
	ldd R16,z+0
	xcall _putcharSmartLCD
	.dbline 340
; 		Delaymsec(5);
	ldi R16,5
	ldi R17,0
	xcall _Delaymsec
	.dbline 341
; 		}
L66:
	.dbline 338
	inc R10
L68:
	.dbline 338
	movw R16,R12
	xcall _strlen
	mov R2,R10
	clr R3
	cp R2,R16
	cpc R3,R17
	brlo L65
X0:
	.dbline -2
L64:
	.dbline 0 ; func end
	xjmp pop_xgset003C
	.dbsym r i 10 c
	.dbsym r strg 12 pc
	.dbend
	.dbfunc e Display_SmartLCD _Display_SmartLCD fV
;           apos -> y+16
;           zpos -> y+12
;           ypos -> y+8
;           xpos -> y+4
	.even
_Display_SmartLCD::
	sbiw R28,20
	.dbline -1
	.dbline 345
; }
; 
; void Display_SmartLCD()
; {
	.dbline 350
;     float xpos,ypos,zpos,apos;
; 	
; 	//xpos = ((float)xoldpos)*xresolution;
; 	//if(xdirpolarity==NEGATIVE)  xpos = -xpos;
; 	Write_Float_SmartLCD(SMARTLCDTWIADDRESS,'x',xpos);
	ldd R2,y+4
	ldd R3,y+5
	ldd R4,y+6
	ldd R5,y+7
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	ldi R18,120
	ldi R16,38
	xcall _Write_Float_SmartLCD
	.dbline 351
; 	Delaymsec(4);
	ldi R16,4
	ldi R17,0
	xcall _Delaymsec
	.dbline 355
; 	
; 	//ypos = ((float)yoldpos)*yresolution;
; 	//if(ydirpolarity==NEGATIVE)  ypos = -ypos;
; 	Write_Float_SmartLCD(SMARTLCDTWIADDRESS,'y',ypos);
	ldd R2,y+8
	ldd R3,y+9
	ldd R4,y+10
	ldd R5,y+11
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	ldi R18,121
	ldi R16,38
	xcall _Write_Float_SmartLCD
	.dbline 356
; 	Delaymsec(4);
	ldi R16,4
	ldi R17,0
	xcall _Delaymsec
	.dbline 360
; 
; 	//zpos = ((float)zoldpos)*zresolution;
; 	//if(zdirpolarity==NEGATIVE)  zpos = -zpos;
; 	Write_Float_SmartLCD(SMARTLCDTWIADDRESS,'z',zpos);
	ldd R2,y+12
	ldd R3,y+13
	ldd R4,y+14
	ldd R5,y+15
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	ldi R18,122
	ldi R16,38
	xcall _Write_Float_SmartLCD
	.dbline 361
; 	Delaymsec(4);
	ldi R16,4
	ldi R17,0
	xcall _Delaymsec
	.dbline 365
; 					  
; 	//apos = ((float)holdpos)*aresolution;
; 	//if(adirpolarity==NEGATIVE)  apos = -apos;
; 	Write_Float_SmartLCD(SMARTLCDTWIADDRESS,'a',apos);
	ldd R2,y+16
	ldd R3,y+17
	ldd R4,y+18
	ldd R5,y+19
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	ldi R18,97
	ldi R16,38
	xcall _Write_Float_SmartLCD
	.dbline -2
L69:
	.dbline 0 ; func end
	adiw R28,20
	ret
	.dbsym l apos 16 D
	.dbsym l zpos 12 D
	.dbsym l ypos 8 D
	.dbsym l xpos 4 D
	.dbend
	.dbfunc e Read_caliper _Read_caliper fL
	.dbunion 1 4 .71
	.dbfield 0 tempbuf A[4:4]c
	.dbfield 0 outint L
	.dbend
; caliperReading -> <dead>
;     returnCode -> R10
;    returnValue -> y+4
;             u2 -> y+0
	.even
_Read_caliper::
	st -y,R10
	sbiw R28,8
	.dbline -1
	.dbline 370
; 	//delaymsec(5);
; }
; 
; long int Read_caliper()
; {	
	.dbline 381
; 	unsigned char caliperReading;
; 	long int returnValue;
; 	unsigned char returnCode;
; 	union {
; 	    unsigned char tempbuf[4];
; 		long int outint;
; 		} u2;
; 		
; 		
; 	//reading digital caliper
; 	u2.outint = 0;
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	std y+0,R24
	std y+1,R25
	std y+2,R26
	std y+3,R27
	.dbline 382
; 	u2.tempbuf[0]=0;
	clr R2
	std y+0,R2
	.dbline 383
; 	u2.tempbuf[1]=0;
	std y+1,R2
	.dbline 384
; 	u2.tempbuf[2]=0;
	std y+2,R2
	.dbline 385
; 	u2.tempbuf[3]=0;
	std y+3,R2
L75:
	.dbline 388
; 	
; 	
; 	while ((PIND & (1<< DDD7))==0 );
L76:
	.dbline 388
	sbis 0x9,7
	rjmp L75
X1:
	.dbline 390
; 	
; 	returnCode = TWI_Start_Read(ATTINY85ADDRESS,4);
	ldi R18,4
	ldi R16,16
	xcall _TWI_Start_Read
	mov R10,R16
	.dbline 394
; 	//printf("return code: %x\n\r", returnCode );
; 		//Delaymsec(100);
; 		
; 	if (returnCode ==0)
	tst R16
	brne L78
X2:
	.dbline 395
; 	{	
	.dbline 396
; 		TWI_Get_Data_From_Transceiver(messageBuf,4);
	ldi R18,4
	ldi R16,<_messageBuf
	ldi R17,>_messageBuf
	xcall _TWI_Get_Data_From_Transceiver
	.dbline 397
; 	   	u2.tempbuf[0]=messageBuf[0];
	lds R2,_messageBuf
	std y+0,R2
	.dbline 398
; 		u2.tempbuf[1]=messageBuf[1];
	lds R2,_messageBuf+1
	std y+1,R2
	.dbline 399
; 		u2.tempbuf[2]=messageBuf[2];
	lds R2,_messageBuf+2
	std y+2,R2
	.dbline 400
; 		u2.tempbuf[3]=0;
	clr R2
	std y+3,R2
	.dbline 405
; 	   	//Delaymsec(100);
; 		// printf(" caliper0: %x\n\r", u2.tempbuf[0]);
; 		// printf(" caliper1: %x\n\r", u2.tempbuf[1]);
; 		//printf(" caliper2: %x\n\r", u2.tempbuf[2]);
; 	}
L78:
	.dbline 407
; 	
; 	returnValue = u2.outint ;
	ldd R2,y+0
	ldd R3,y+1
	ldd R4,y+2
	ldd R5,y+3
	std y+4,R2
	std y+5,R3
	std y+6,R4
	std y+7,R5
	.dbline 409
; 	
; 	return returnValue;
	ldd R16,y+4
	ldd R17,y+5
	ldd R18,y+6
	ldd R19,y+7
	.dbline -2
L70:
	.dbline 0 ; func end
	adiw R28,8
	ld R10,y+
	ret
	.dbsym l caliperReading 1 c
	.dbsym r returnCode 10 c
	.dbsym l returnValue 4 L
	.dbsym l u2 0 S[.71]
	.dbend
	.dbfunc e Enumerate_ADS _Enumerate_ADS fV
	.even
_Enumerate_ADS::
	.dbline -1
	.dbline 413
; }
; 
; void Enumerate_ADS()
; {
	.dbline 415
;  	 
; 	  ADSstate = 0;
	clr R2
	sts _ADSstate,R2
	.dbline 417
; 	 // Check for ADS
; 	 Init_ADS1100_TWI(ADS1100ADDRESS);
	ldi R16,73
	xcall _Init_ADS1100_TWI
	.dbline 418
;      if(TWI_Get_State_Info()!=TWI_MTX_ADR_NACK) {
	xcall _TWI_Get_State_Info
	cpi R16,32
	breq L86
X3:
	.dbline 418
	.dbline 419
; 	 	ADSstate |= 0x01;
	lds R24,_ADSstate
	ori R24,1
	sts _ADSstate,R24
	.dbline 420
; 	 	 Delaymsec(7);
	ldi R16,7
	ldi R17,0
	xcall _Delaymsec
	.dbline 421
; 		 }
L86:
	.dbline -2
L85:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Enumerate_BMP085 _Enumerate_BMP085 fV
	.even
_Enumerate_BMP085::
	.dbline -1
	.dbline 425
; }
; 
; void Enumerate_BMP085()
; {
	.dbline 426
; 	 BMPstate = bmpac1 = 0;
	clr R2
	clr R3
	sts _bmpac1+1,R3
	sts _bmpac1,R2
	sts _BMPstate,R2
	.dbline 428
; 	 // Check for ADS
; 	 bmpac1 = Read_BMP085_EEPROM_Signed(0xaa);
	ldi R16,170
	xcall _Read_BMP085_EEPROM_Signed
	sts _bmpac1+1,R17
	sts _bmpac1,R16
	.dbline 430
; 	 //printf("bmpac1 = %d\n\r",bmpac1);
;      if(bmpac1!=0) {
	cpi R16,0
	cpc R16,R17
	breq L89
X4:
	.dbline 430
	.dbline 431
; 	 	 BMPstate |= 0x01;
	lds R24,_BMPstate
	ori R24,1
	sts _BMPstate,R24
	.dbline 432
; 	 	 Delaymsec(7);
	ldi R16,7
	ldi R17,0
	xcall _Delaymsec
	.dbline 433
; 		 }
L89:
	.dbline -2
L88:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Enumerate_SmartLCD _Enumerate_SmartLCD fV
	.even
_Enumerate_SmartLCD::
	.dbline -1
	.dbline 437
; }
; 
; void Enumerate_SmartLCD()
; {
	.dbline 438
;  	 smartlcdstate = 0;
	clr R2
	sts _smartlcdstate,R2
	.dbline 441
; 	 
; 	 // Check for Smart Joystick
; 	 Init_SmartLCD_TWI(SMARTLCDTWIADDRESS);
	ldi R16,38
	xcall _Init_SmartLCD_TWI
	.dbline 442
;      if(TWI_Get_State_Info()!=TWI_MTX_ADR_NACK) {
	xcall _TWI_Get_State_Info
	cpi R16,32
	breq L92
X5:
	.dbline 442
	.dbline 443
; 	 	 smartlcdstate |= 0x01;
	lds R24,_smartlcdstate
	ori R24,1
	sts _smartlcdstate,R24
	.dbline 444
; 	 	 Delaymsec(50);
	ldi R16,50
	ldi R17,0
	xcall _Delaymsec
	.dbline 446
; 	 	 //Display_SmartLCD();
; 		 }
L92:
	.dbline -2
L91:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Enumerate_DigitalCompass _Enumerate_DigitalCompass fV
	.even
_Enumerate_DigitalCompass::
	.dbline -1
	.dbline 450
; }
; 
; void Enumerate_DigitalCompass()
; {
	.dbline 451
;  	 digitalcompassstate = 0;
	clr R2
	sts _digitalcompassstate,R2
	.dbline 455
; 	 
; 	 // Send A command to digital compass to start a conversion
; 	 //printf("Init compass\n\r");
; 	 Init_DigitalCompass_TWI();
	xcall _Init_DigitalCompass_TWI
	.dbline 456
;      if(TWI_Get_State_Info()!=TWI_MTX_ADR_NACK) {
	xcall _TWI_Get_State_Info
	cpi R16,32
	breq L95
X6:
	.dbline 456
	.dbline 457
; 	 	 digitalcompassstate |= 0x01;
	lds R24,_digitalcompassstate
	ori R24,1
	sts _digitalcompassstate,R24
	.dbline 458
; 		 Read_DigitalCompass_Heading();  // read first wrong value
	xcall _Read_DigitalCompass_Heading
	.dbline 459
; 	 	 Delaymsec(7);
	ldi R16,7
	ldi R17,0
	xcall _Delaymsec
	.dbline 460
; 		 }
L95:
	.dbline -2
L94:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Enumerate_HMC5883 _Enumerate_HMC5883 fV
	.even
_Enumerate_HMC5883::
	.dbline -1
	.dbline 464
; }
; 
; void Enumerate_HMC5883()
; {
	.dbline 465
;  	 hmc5883state = 0;
	clr R2
	sts _hmc5883state,R2
	.dbline 469
; 	 
; 	 // Send A command to digital compass to start a conversion
; 	 //printf("Init compass\n\r");
; 	 Init_HMC5883_TWI();
	xcall _Init_HMC5883_TWI
	.dbline 470
;      if(TWI_Get_State_Info()!=TWI_MTX_ADR_NACK) {
	xcall _TWI_Get_State_Info
	cpi R16,32
	breq L98
X7:
	.dbline 470
	.dbline 471
; 	 	 hmc5883state |= 0x01;
	lds R24,_hmc5883state
	ori R24,1
	sts _hmc5883state,R24
	.dbline 473
; 		 //Read_DigitalCompass_Heading();  // read first wrong value
; 	 	 Delaymsec(7);
	ldi R16,7
	ldi R17,0
	xcall _Delaymsec
	.dbline 474
; 		 }
L98:
	.dbline -2
L97:
	.dbline 0 ; func end
	ret
	.dbend
	.area lit(rom, con, rel)
_enummes1::
	.byte 10,13,'E,'n,'u,'m,'e,'r,'a,'t,'e,32,'T,'W,'I,32
	.byte 'D,'e,'v,'i,'c,'e,'s,10,13,0
	.dbsym e enummes1 _enummes1 A[26:26]kc
_enummes8::
	.byte 32,'N,'o,32,'S,'m,'a,'r,'t,'L,'C,'D,32,'f,'o,'u
	.byte 'n,'d,10,13,0
	.dbsym e enummes8 _enummes8 A[21:21]kc
_enummes9::
	.byte 32,'S,'m,'a,'r,'t,'L,'C,'D,32,'f,'o,'u,'n,'d,32
	.byte 45,32,'e,'n,'a,'b,'l,'e,'d,10,13,0
	.dbsym e enummes9 _enummes9 A[28:28]kc
_enummes10::
	.byte 32,'N,'o,32,'D,'i,'g,'i,'t,'a,'l,32,'C,'o,'m,'p
	.byte 'a,'s,'s,10,13,0
	.dbsym e enummes10 _enummes10 A[22:22]kc
_enummes11::
	.byte 32,'D,'i,'g,'i,'t,'a,'l,32,'C,'o,'m,'p,'a,'s,'s
	.byte 32,'f,'o,'u,'n,'d,10,13,0
	.dbsym e enummes11 _enummes11 A[25:25]kc
_enummes12::
	.byte 32,'N,'o,32,'A,'D,'S,49,49,48,48,10,13,0
	.dbsym e enummes12 _enummes12 A[14:14]kc
_enummes13::
	.byte 32,'A,'D,'S,49,49,48,48,32,'f,'o,'u,'n,'d,10,13
	.byte 0
	.dbsym e enummes13 _enummes13 A[17:17]kc
_enummes14::
	.byte 32,'N,'o,32,'B,'M,'P,48,56,53,32,49,32,'f,'o,'u
	.byte 'n,'d,10,13,0
	.dbsym e enummes14 _enummes14 A[21:21]kc
_enummes15::
	.byte 32,'B,'M,'P,48,56,53,32,49,32,'f,'o,'u,'n,'d,10
	.byte 13,0
	.dbsym e enummes15 _enummes15 A[18:18]kc
_enummes16::
	.byte 32,'N,'o,32,'B,'M,'P,48,56,53,32,50,32,'f,'o,'u
	.byte 'n,'d,10,13,0
	.dbsym e enummes16 _enummes16 A[21:21]kc
_enummes17::
	.byte 32,'B,'M,'P,48,56,53,32,50,32,'f,'o,'u,'n,'d,10
	.byte 13,0
	.dbsym e enummes17 _enummes17 A[18:18]kc
_enummes18::
	.byte 32,'N,'o,32,'H,'M,'C,53,56,56,51,32,'f,'o,'u,'n
	.byte 'd,10,13,0
	.dbsym e enummes18 _enummes18 A[20:20]kc
_enummes19::
	.byte 32,'H,'M,'C,53,56,56,51,32,'f,'o,'u,'n,'d,10,13
	.byte 0
	.dbsym e enummes19 _enummes19 A[17:17]kc
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_TWI_Functions.c
	.dbfunc e Enumerate_TWI_Devices _Enumerate_TWI_Devices fV
;              i -> <dead>
;      motormask -> R20
	.even
_Enumerate_TWI_Devices::
	st -y,R20
	.dbline -1
	.dbline 492
; }
; 
; const char enummes1[] = "\n\rEnumerate TWI Devices\n\r";
; const char enummes8[] = " No SmartLCD found\n\r";
; const char enummes9[] = " SmartLCD found - enabled\n\r";
; const char enummes10[] = " No Digital Compass\n\r";
; const char enummes11[] = " Digital Compass found\n\r";
; const char enummes12[] = " No ADS1100\n\r";
; const char enummes13[] = " ADS1100 found\n\r";
; const char enummes14[] = " No BMP085 1 found\n\r";
; const char enummes15[] = " BMP085 1 found\n\r";
; const char enummes16[] = " No BMP085 2 found\n\r";
; const char enummes17[] = " BMP085 2 found\n\r";
; const char enummes18[] = " No HMC5883 found\n\r";
; const char enummes19[] = " HMC5883 found\n\r";
; 
; void Enumerate_TWI_Devices()
; {
	.dbline 493
;  	 unsigned char i,motormask=0x01;
	ldi R20,1
	.dbline 495
; 	
; 	 putfs(enummes1);	
	ldi R16,<_enummes1
	ldi R17,>_enummes1
	xcall _putfs
	.dbline 498
; 	 
; 	 // Enumerate ADS1100
; 	 Enumerate_ADS();
	xcall _Enumerate_ADS
	.dbline 499
; 	 if(ADSstate==0) putfs(enummes12);
	lds R2,_ADSstate
	tst R2
	brne L101
X8:
	.dbline 499
	ldi R16,<_enummes12
	ldi R17,>_enummes12
	xcall _putfs
	xjmp L102
L101:
	.dbline 500
; 	 else putfs(enummes13);
	ldi R16,<_enummes13
	ldi R17,>_enummes13
	xcall _putfs
L102:
	.dbline 504
; 	 
; 	 // Enumerate BMP085 Sensor 1
; //	 EnableBMP085(BMPSENSOR1);
; 	 Enumerate_BMP085();
	xcall _Enumerate_BMP085
	.dbline 505
; 	 if(BMPstate==0) putfs(enummes14);
	lds R2,_BMPstate
	tst R2
	brne L103
X9:
	.dbline 505
	ldi R16,<_enummes14
	ldi R17,>_enummes14
	xcall _putfs
	xjmp L104
L103:
	.dbline 506
; 	 else putfs(enummes15);
	ldi R16,<_enummes15
	ldi R17,>_enummes15
	xcall _putfs
L104:
	.dbline 514
; //	 EnableBMP085(BMPSENSOR2);
; //	 BMPstate = 0;
; //	 Enumerate_BMP085();
; //	 if(BMPstate==0) putfs(enummes16);
; //	 else putfs(enummes17);
; 	 
; 	 // Enumerate SmartLCD
; 	 Enumerate_SmartLCD();
	xcall _Enumerate_SmartLCD
	.dbline 515
; 	 if(smartlcdstate==0) putfs(enummes8);
	lds R2,_smartlcdstate
	tst R2
	brne L105
X10:
	.dbline 515
	ldi R16,<_enummes8
	ldi R17,>_enummes8
	xcall _putfs
	xjmp L106
L105:
	.dbline 516
; 	 else putfs(enummes9);
	ldi R16,<_enummes9
	ldi R17,>_enummes9
	xcall _putfs
L106:
	.dbline 519
; 	 
; 	 // Enumerate Digital Compass
; 	 Enumerate_DigitalCompass();
	xcall _Enumerate_DigitalCompass
	.dbline 520
; 	 if(digitalcompassstate==0) putfs(enummes10);
	lds R2,_digitalcompassstate
	tst R2
	brne L107
X11:
	.dbline 520
	ldi R16,<_enummes10
	ldi R17,>_enummes10
	xcall _putfs
	xjmp L108
L107:
	.dbline 521
; 	 else putfs(enummes11);
	ldi R16,<_enummes11
	ldi R17,>_enummes11
	xcall _putfs
L108:
	.dbline 523
; 	 
; 	 Enumerate_HMC5883();
	xcall _Enumerate_HMC5883
	.dbline 524
; 	 if(hmc5883state==0) putfs(enummes18);
	lds R2,_hmc5883state
	tst R2
	brne L109
X12:
	.dbline 524
	ldi R16,<_enummes18
	ldi R17,>_enummes18
	xcall _putfs
	xjmp L110
L109:
	.dbline 525
; 	 else putfs(enummes19);
	ldi R16,<_enummes19
	ldi R17,>_enummes19
	xcall _putfs
L110:
	.dbline -2
L100:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym l i 1 c
	.dbsym r motormask 20 c
	.dbend
	.area lit(rom, con, rel)
_TWImess1::
	.byte 10,13,'T,'W,'I,32,'I,'n,'t,'e,'r,'a,'c,'t,'i,'v
	.byte 'e,32,'C,'o,'m,'m,'a,'n,'d,32,'M,'o,'d,'e,10,13
	.byte 0
	.dbsym e TWImess1 _TWImess1 A[33:33]kc
_TWImess2::
	.byte 'E,'n,'t,'e,'r,32,'t,'w,'i,32,'a,'d,'d,'r,'e,'s
	.byte 's,32,40,'h,'e,'x,45,'t,'w,'o,32,'c,'h,'a,'r,'s
	.byte 41,32,'f,'o,'l,'l,'o,'w,'e,'d,32,'b,'y,32,'A,'S
	.byte 'C,'I,'I,32,'c,'o,'m,'m,'a,'n,'d,'s,10,13,0
	.dbsym e TWImess2 _TWImess2 A[63:63]kc
_TWImess3::
	.byte 32,32,'E,'x,'a,'m,'p,'l,'e,58,32,32,49,52,'x,'t
	.byte 'x,32,32,32,32,'E,'n,'t,'e,'r,32,39,'e,39,32,'t
	.byte 'o,32,'e,'x,'i,'t,10,13,0
	.dbsym e TWImess3 _TWImess3 A[41:41]kc
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_TWI_Functions.c
	.dbfunc e Execute_TWI_Command _Execute_TWI_Command fV
;     twiaddress -> y+2
;           iptr -> R20
	.even
_Execute_TWI_Command::
	xcall push_xgsetF00C
	sbiw R28,3
	.dbline -1
	.dbline 535
; }
; 
; const char TWImess1[] = "\n\rTWI Interactive Command Mode\n\r";
; const char TWImess2[] = "Enter twi address (hex-two chars) followed by ASCII commands\n\r";
; const char TWImess3[] = "  Example:  14xtx    Enter 'e' to exit\n\r";
; 
; // Send commands on I2C bus given twi address and an ASCII string
; //  TBD - get data command
; void Execute_TWI_Command()
; { 
	.dbline 538
;      unsigned char twiaddress,iptr;
; 	  
; 	 putfs(TWImess1);
	ldi R16,<_TWImess1
	ldi R17,>_TWImess1
	xcall _putfs
	.dbline 539
; 	 putfs(TWImess2);
	ldi R16,<_TWImess2
	ldi R17,>_TWImess2
	xcall _putfs
	.dbline 540
; 	 putfs(TWImess3);
	ldi R16,<_TWImess3
	ldi R17,>_TWImess3
	xcall _putfs
	.dbline 541
; 	 putchar(':');
	ldi R16,58
	xcall _putchar$device_specific$
	xjmp L113
L112:
	.dbline 542
;  	 while((instrg[0]=tolower(getcharr()))!='e') {
	.dbline 543
; 	     instrg[1] = getcharr();
	xcall _getcharr
	sts _instrg+1,R16
	.dbline 544
; 		 instrg[2] = 0;
	clr R2
	sts _instrg+2,R2
	.dbline 545
; 		 sscanf(instrg,"%x",&twiaddress);
	movw R24,R28
	adiw R24,2
	std y+1,R25
	std y+0,R24
	ldi R18,<L117
	ldi R19,>L117
	ldi R16,<_instrg
	ldi R17,>_instrg
	xcall _sscanf
	.dbline 546
; 		 iptr = 0;
	clr R20
	xjmp L119
L118:
	.dbline 547
; 	     while((messageBuf[iptr++]=getcharr())!=CR) {
	.dbline 548
; 		     if(iptr==20) break;
	cpi R20,20
	brne L121
X13:
	.dbline 548
	xjmp L120
L121:
	.dbline 549
; 			 }
L119:
	.dbline 547
	mov R2,R20
	clr R3
	subi R20,255    ; addi 1
	push R2
	push R3
	xcall _getcharr
	pop R3
	pop R2
	mov R22,R16
	ldi R24,<_messageBuf
	ldi R25,>_messageBuf
	mov R30,R2
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R22
	cpi R16,13
	brne L118
X14:
L120:
	.dbline 550
; 		 messageBuf[iptr] = 0;
	ldi R24,<_messageBuf
	ldi R25,>_messageBuf
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	clr R2
	std z+0,R2
	.dbline 552
; 		 
; 		 printf("\n\rtwi=%x %s",twiaddress,messageBuf);
	std y+1,R25
	std y+0,R24
	ldd R18,y+2
	clr R19
	ldi R16,<L123
	ldi R17,>L123
	xcall _printf
	.dbline 554
; 		 
; 		 TWI_Start_Write(twiaddress,messageBuf,iptr);
	std y+0,R20
	ldi R18,<_messageBuf
	ldi R19,>_messageBuf
	ldd R16,y+2
	xcall _TWI_Start_Write
	.dbline 556
; 
; 	     putCRLF(); putchar(':');
	xcall _putCRLF
	.dbline 556
	ldi R16,58
	xcall _putchar$device_specific$
	.dbline 557
; 	     }
L113:
	.dbline 542
	xcall _getcharr
	clr R17
	xcall _tolower
	movw R10,R16
	mov R20,R10
	sts _instrg,R20
	cpi R16,101
	breq X16
	xjmp L112
X16:
X15:
	.dbline 558
; 	 putCRLF();
	xcall _putCRLF
	.dbline -2
L111:
	.dbline 0 ; func end
	adiw R28,3
	xjmp pop_xgsetF00C
	.dbsym l twiaddress 2 c
	.dbsym r iptr 20 c
	.dbend
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_TWI_Functions.c
L123:
	.blkb 12
	.area idata
	.byte 10,13,'t,'w,'i,61,37,'x,32,37,'s,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_TWI_Functions.c
L117:
	.blkb 3
	.area idata
	.byte 37,'x,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_TWI_Functions.c
L42:
	.blkb 9
	.area idata
	.byte 'a,'c,54,61,37,'u,10,13,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_TWI_Functions.c
L41:
	.blkb 9
	.area idata
	.byte 'a,'c,53,61,37,'u,10,13,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_TWI_Functions.c
L40:
	.blkb 9
	.area idata
	.byte 'a,'c,52,61,37,'u,10,13,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_TWI_Functions.c
L37:
	.blkb 8
	.area idata
	.byte 'm,'d,61,37,'d,10,13,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_TWI_Functions.c
L36:
	.blkb 8
	.area idata
	.byte 'm,'c,61,37,'d,10,13,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_TWI_Functions.c
L35:
	.blkb 8
	.area idata
	.byte 'm,'b,61,37,'d,10,13,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_TWI_Functions.c
L34:
	.blkb 9
	.area idata
	.byte 'b,'p,50,61,37,'d,10,13,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_TWI_Functions.c
L33:
	.blkb 9
	.area idata
	.byte 'b,'p,49,61,37,'d,10,13,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_TWI_Functions.c
L32:
	.blkb 9
	.area idata
	.byte 'a,'c,51,61,37,'d,10,13,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_TWI_Functions.c
L31:
	.blkb 9
	.area idata
	.byte 'a,'c,50,61,37,'d,10,13,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_TWI_Functions.c
L30:
	.blkb 9
	.area idata
	.byte 'a,'c,49,61,37,'d,10,13,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_TWI_Functions.c
L29:
	.blkb 34
	.area idata
	.byte 10,13,'B,'M,'P,48,56,53,32,'C,'a,'l,'i,'b,'r,'a
	.byte 't,'i,'o,'n,32,'P,'a,'r,'a,'m,'e,'t,'e,'r,'s,10
	.byte 13,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_TWI_Functions.c
; }
; 
